/* 
  Trial 1, Rev A
*/

#include "simpletools.h"                       // Include libraries
#include "abdrive.h"

int getQTIs(int highPin, int lowPin);          // Forward declare function
void final_line();
void straight();
void forward();
void left();
void right();
void acceleration();

void work_around();
void work_around0();
void work_around1();
void work_around2();
void work_around3();
void work_around4();
void work_around5();
void work_around6();
void work_around7();
void work_around8();
void work_around9();
void work_around10();
void work_around11();
void work_around12();
void work_around13();
void work_around14();
void work_around15();
void work_around16();
void work_around17();


int a;
int b; 
int c;


int main()                                   // Main function
{  
 a==0;
 b==0;
 c==0;
 

  while(1)                                     // Main loop
  {
    
    int qtis = getQTIs(7, 4);                  // Check stripe position
    
//Line Following Code
    
    //Left
    if(qtis == 0b1000) {              // Far left, rotate left

         work_around();
         drive_speed(40,64);    
  }      
    if(qtis == 0b1100){              
         work_around();// Left, pivot left
         drive_speed(54,64);    
  }        
    if(qtis == 0b0100) {              
         work_around();// A little left, curve left
         drive_speed(60,64);    
  }        
    //Right
    if(qtis == 0b0010) {              
         work_around();// A little right, curve right
         drive_speed(64,60);    
  }       
    if(qtis == 0b0011) {              
         work_around();// Right, pivot right
         drive_speed(64,54);    
  }      
    if(qtis == 0b0001) {              
         work_around();// Far right, rotate right 
         drive_speed(64,40);    
  }       
  
    //Forward on the Line                  // Stripe centered, forward 
    if(qtis == 0b0110) {              
         work_around();
         drive_speed(64,64);    
  }    
    
//Main Junction Control
           
    //Junction Left 
    if(qtis == 0b1110){                        // Left turn                 
      if (a==1||a==3||a==4||a==5||a==10||a==11||a==12||a==13||a==18||a==19||a==20)left();

       else if(a==6||a==7||a==8||a==9||a==15||a==16||a==17)right();
   
       else if (a == 0||a==2||a==14)forward();    
       
       else if (a==21)final_line();        
       
       a++;
     }       
   
    //Junction Right
    if(qtis == 0b0111){                        // Right Turn
      if(a==6||a==7||a==8||a==9||a==15||a==16||a==17)right();
      
       else if (a==1||a==3||a==4||a==5||a==10||a==11||a==12||a==13||a==18||a==19||a==20)left();
      
       else if (a == 0||a==2||a==14)forward();
       
       else if (a==21)final_line(); 
              
       a++;
    }    
    
    //Initial Start/Final Stop
    if(qtis == 0b0000){
      if(a == 0)  straight();            // Starting forward with no line
      
      else if(a==22) drive_speed(0,0);      
       }   
       
    
    //Junction Forward
    if(qtis == 0b1111) {     
      if(a==6||a==7||a==8||a==9||a==15||a==16||a==17)right();
      
       else if (a==1||a==3||a==4||a==5||a==10||a==11||a==12||a==13||a==18||a==19||a==20)left();
      
       else if (a == 0||a==2||a==14)forward();
       
       else if (a==21)final_line();
                   
       a++;
  }    
     // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c);
  }
}

int getQTIs(int highPin, int lowPin)           // Function - getQTIs
{
  int dt = (CLKFREQ / 1000000) * 230;          // Set up 230 us time increment
  set_outputs(highPin, lowPin, 0b1111);        // highPin...lowPin set high
  set_directions(highPin, lowPin, 0b1111);     // highPin...lowPin set to output
  waitcnt(dt + CNT);                           // Wait 230 us
  set_directions(highPin, lowPin, 0b0000);     // highPin...lowPin st to input
  waitcnt(dt + CNT);                           // Wait 230 us
  int qtis = get_states(highPin, lowPin);      // Get 4-bit pattern QTIs apply 
  return qtis;                                 // Return val containing pattern
}
void straight(){
  drive_speed(64,64);
  
}  
void forward(){
  drive_speed(64,64);
  pause(100);
}  
void left(){
  drive_speed(0,64);
  pause(700);
}  
void right(){
  drive_speed(64,0);
  pause(700);
}  

void final_line(){
    drive_speed(64,64);
  pause(2000);
}  
void work_around(){
        if (a==2 && b==0)work_around0();
        else if (a==2  &&  b==1)work_around1();
        else if (a==3  &&  b==2)work_around2();
        else if (a==3  &&  b==3)work_around3();
        else if (a==4  &&  b==4)work_around4();
        else if (a==5  &&  b==5)work_around5();
        else if (a==9  &&  b==6)work_around6();
        else if (a==11  &&  b==7)work_around7();
        else if (a==12  &&  b==8)work_around8();
        else if (a==13  &&  b==9)work_around9();
        else if (a==13  &&  b==10)work_around10();
        else if (a==16  &&  b==11)work_around11();
        else if (a==17  &&  b==12)work_around12();
        else if (a==17  &&  b==13)work_around13();
        else if (a==18  &&  b==14)work_around14();
        else if (a==19  &&  b==15)work_around15();
        else if (a==20  &&  b==16)work_around16();
        else if (a==21  &&  b==17)work_around17();
      
        else return;
      }        
void work_around0(){
   b++;
  for(c==0;c<1100;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(128,128);
    //Left  
    if(qtis == 0b1000) drive_speed(98, 128);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(118, 128);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(123, 128);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(128, 123);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(128, 118);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(128, 98); 
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c);
    }
}  
void work_around1(){  
   b++;
  for(c==0;c<900;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
 void work_around2(){
   b++;
  for(c==0;c<2400;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(128,128);
    //Left  
    if(qtis == 0b1000) drive_speed(118, 128);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(118, 128);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(123, 128);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(128, 123);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(128, 118);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(128, 98); 
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c);
    }
  }
void work_around3(){
   b++;
  for(c==0;c<1000;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  }  
void work_around4(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  }  
void work_around5(){
   b++;
  for(c==0;c<1000;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around6(){
   b++;
  for(c==0;c<4000;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  }   
void work_around7(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around8(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around9(){
   b++;
  for(c==0;c<2400;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(128,128);
    //Left  
    if(qtis == 0b1000) drive_speed(118, 128);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(118, 128);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(123, 128);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(128, 123);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(128, 118);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(128, 98);
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around10(){
   b++;
  for(c==0;c<1000;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
    
       //   printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around11(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
    
       //   printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around12(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
    
        //  printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around13(){
   b++;
  for(c==0;c<2400;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(128,128);
    //Left  
    if(qtis == 0b1000) drive_speed(118, 128);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(118, 128);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(123, 128);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(128, 123);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(128, 118);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(128, 98);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around14(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around15(){
   b++;
  for(c==0;c<1100;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(128,128);
    //Left  
    if(qtis == 0b1000) drive_speed(98, 128);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(118, 128);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(123, 128);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(128, 123);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(128, 118);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(128, 98); 
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
 void work_around16(){
   b++;
  for(c==0;c<900;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
void work_around17(){
   b++;
  for(c==0;c<3500;c++){
      
    int qtis = getQTIs(7, 4);  
      
    if(qtis == 0b0110)drive_speed(100,100);
    //Left  
    if(qtis == 0b1000) drive_speed(70, 100);    // Far left, rotate left
    if(qtis == 0b1100) drive_speed(90, 100);    // Left, pivot left
    if(qtis == 0b0100) drive_speed(95, 100);    // A little left, curve left
  
    //Right
    if(qtis == 0b0010) drive_speed(100, 95);    // A little right, curve right
    if(qtis == 0b0011) drive_speed(100, 90);    // Right, pivot right
    if(qtis == 0b0001) drive_speed(100, 70);
    
         // printf("%c,a=%d,b=%d,c=%d\n",CLS,a,b,c); 
    }
  } 
